{
  P/M Graphics demonstration
  by Bostjan Gorisek 2015
  
  Developed in Mad-Pascal by Tebe / Madteam
}
uses crt, graph, pmg;

var
  // Player data
  p0Data : array [0.._P_MAX] of byte = (60, 66, 129, 165, 129, 153, 129, 165, 153, 66, 60, 0, 0, 0, 0);
  p1Data : array [0.._P_MAX] of byte = (124, 130, 254, 254, 124, 56, 16, 16, 16, 16, 16, 16, 16, 124, 254);
  p2Data : array [0.._P_MAX] of byte = (60, 102, 110, 118, 118, 118, 102, 60, 24, 0, 0, 0, 0, 0, 0);
  p3Data : array [0.._P_MAX] of byte = (10, 20, 30, 40, 50, 60, 70, 80, 55, 28, 255,0, 0, 0, 0);
  // Missile data
  m0Data : array [0.._M0_MAX] of byte = (3, 1, 2);
  m1Data : array [0.._M1_MAX] of byte = (8);
  m2Data : array [0.._M2_MAX] of byte = (32, 16, 32, 16);
  m3Data : array [0.._M3_MAX] of byte = (192, 128, 128, 128, 64);

// Main code
begin
  // Set graphics mode and playfield colors
  InitGraph(0);
  
  // Initialize P/M custom variables
  p_data[0] := @p0Data;
  p_data[1] := @p1Data;
  p_data[2] := @p2Data;
  p_data[3] := @p3Data;
  m_data[0] := @m0Data;
  m_data[1] := @m1Data;
  m_data[2] := @m2Data;
  m_data[3] := @m3Data;
  
  // Initialize P/M graphics
  SetPM(_PM_DOUBLE_RES);
  InitPM(_PM_DOUBLE_RES);  
  
  // Program color setup
  TextBackground(0); SetBkColor (192); CursorOff;
  
  writeln(eol, 'P/M Graphics demonstration');
  writeln(eol, 'by Bostjan Gorisek and Tebe 2015', eol);

  // Turn on P/M graphics
  ShowPM(_PM_SHOW_ON);

  // Set P/M colors    
  ColorPM(0, 202);
  ColorPM(1, 250);
  ColorPM(2, 136);
  ColorPM(3, 36);

  // Set player sizes
  SizeP(0, _PM_DOUBLE_SIZE);
  SizeP(1, _PM_DOUBLE_SIZE);
  SizeP(2, _PM_QUAD_SIZE);
  SizeP(3, _PM_NORMAL_SIZE);
  // Set missile sizes
  SizeM(_PM_NORMAL_SIZE, _PM_DOUBLE_SIZE, _PM_QUAD_SIZE, _PM_QUAD_SIZE);

  // Position and show players
  MoveP(0, 60, 70);
  MoveP(1, 170, 90);
  MoveP(2, 100, 85);
  MoveP(3, 140, 100);
  // Position and show missiles
  MoveM(0, 120, 68);
  MoveM(1, 130, 72);
  MoveM(2, 140, 76);
  MoveM(3, 155, 82);
  
  repeat until keypressed;

  // Reset P/M graphics
  ShowPM(_PM_SHOW_OFF);
end.
